var MR_ID = 0;
var MR_EXTERNAL_ID = 0;
$(document).ready(function () {

    $('#btnRetrieveMR').on('click', function () {

        retrieveMrHeader();
    });




    $('#tblMrHeader tbody').on('click', 'tr', function () {
        $(this).addClass('selected').siblings().removeClass('selected');
        MR_ID = $(this).find('td:first').html();
        retrieveMrData(MR_ID);
    });


    $('#btnGetDataMR').on('click',function(){
        $('#mrDataModal').modal('hide');
        setSelectedMRHeader(MR_ID);
        setSelectedMR(MR_ID);
    });
});


function retrieveMrHeader() {

    $.ajax({
        type: "GET",
        url: "/sc/RetrieveMRController/allMaterialRequisition",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            if (response.data.success) {

                console.log(response);
                $('#tblBodyMrHeader').empty();
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['internal_id'];
                    var refferance_id = response.data.result[i]['external_id'];
                    var date = response.data.result[i]['trans_date'];
                    var store = response.data.result[i]['store'];
                    var department = response.data.result[i]['department'];

                    var row = '<tr><td hidden>' + id + '</td>';
                    row += '<td>' + date + '</td>';
                    row += '<td>' + refferance_id + '</td>';
                    row += '<td>' + store + '</td>';
                    row += '<td>' + department + '</td></tr>';
                    $('#tblBodyMrHeader').append(row);

                }


            }
        },

        error: function (error) {
            console.log(error);


        },
        complete: function () {
            $('#mrDataModal').modal('show');
        }

    });

}




function retrieveMrData(id) {

    $.ajax({
        type: "GET",
        url: "/sc/RetrieveMRController/allMaterialRequisitionData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            if (response.data.success) {

                console.log(response);
                $('#tblBopdyMrData').empty();
                for (i = 0; i < response.data.result.length; i++) {
                    var product_id = response.data.result[i]['product_id'];
                    var product_name = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var unit = response.data.result[i]['unit'];

                    var row = '<tr><td>' + product_id + '</td>';
                    row += '<td>' + product_name + '</td>';
                    row += '<td>' + quantity + '</td>';
                    row += '<td>' + unit + '</td></tr>';
                    $('#tblBopdyMrData').append(row);

                }


            }
        },

        error: function (error) {
            console.log(error);


        },
        complete: function () {
            $('#mrDataModal').modal('show');
        }

    });

}





function setSelectedMRHeader(id) {

    $.ajax({
        type: "GET",
        url: "/sc/RetrieveMRController/getSelectedMRHeader/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            setSelectedOption('cmbDepartment',res.dept_id);
            $('#txtSupervisor').val(res.employee_name);
            setSelectedOption('cmbStores',res.store_id);
            setSelectedOption('cmbMiType',res.mi_type);
            //setSelectedOption('cmbMachine',res.machine_id);
            $('#txtVehicleNo').val(res.vehicle_no);
            setSelectedOption('cmbManufacturingOrder',res.manufacturing_order_number);
            $('#cmbProjectCode').val(res.project_code);
            $('#cmbStores').change();
            $('#cmbMiType').change();

        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {
            progress(false);
        }

    });
}



function setSelectedMR(id) {

    $.ajax({
        type: "GET",
        url: "/sc/RetrieveMRController/getSelectedMR/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            GOODS_TRANSFER_ID = res.internal_id;
            MR_EXTERNAL_ID = res.external_id;
            //referanceID = res.external_id;
            //$('#txtExternal_id').val(res.external_id);
            //$('#txtGrnDate').val(res.trans_date);
            //setSelectedOption('cmbStoresFrom', res.store_from_id);
            setSelectedOption('cmbStores', res.store_id);
            tableData.clear();
            var request_data = res.data;
            for (var i = 0; i < request_data.length; i++) {
                tableData.addRow(
                    [
                        { 'type': 'string', 'val': request_data[i].product_primary_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'string', 'val': request_data[i].product_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].product, 'align': 'left', 'width': '100%' },
                        {
                            'type': 'select', 'val': request_data[i].uom, 'align': 'left', 'width': '100px'
                        },
                        { 'type': 'string', 'val': getAvailableQty(request_data[i].product_primary_id,$('#cmbStores').val()), 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].quantity, 'align': 'right', 'width': '100px' },
                        { 'type': 'hidden', 'val': request_data[i].quantity, 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].comments, 'align': 'left', 'width': '200px' },
                        { 'type': 'remove', 'val': 'X', 'align': 'center', 'width': '50px' }]
                );
            }

        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {
            progress(false);
        }

    });
}